#!/bin/sh
#
# /etc/rc.d/scripts/idetune - run once at boot time from rc.sysinit
#
# Turn on ide device optimization.
# There is only one file /etc/sysconfig/harddisks with default paramenetrs for all disks.
# If you need different hdparm parameters for some of your devices, copy
# /etc/sysconfig/harddisks to /etc/sysconfig/harddisk/hda (hdb, hdc...) and modify it.
# each device which has no special parameters will use the defaults.
#
# MULTIPLE_IO patched 12.12.2001 by Vadim Illarionov <DIMMeach@pisem.net>
#

. /etc/init.d/functions

HDPARM=/sbin/hdparm
[ -x "$HDPARM" ] || exit 0

for i in a b c d e f g h; do
	for parm in EIDE_32BIT EXTRA_PARAMS HDFLAGS LOOKAHEAD MULTIPLE_IO SPEED UNMASKIRQ USE_DMA sourced; do
		unset $parm
	done
	if [ -e /proc/ide/hd$i/media ]; then
		SourceIfNotEmpty /etc/sysconfig/harddisks && sourced=1
		SourceIfNotEmpty /etc/sysconfig/harddisk/hd$i && sourced=1
		[ -n "$sourced" ] || continue
		case $i in
			a) disk="Primary Master"	;;
			b) disk="Primary Slave"		;;
			c) disk="Secondary Master"	;;
			d) disk="Secondary Slave"	;;
			e) disk="Tertiary Master"	;;
			f) disk="Tertiary Slave"	;;
			g) disk="Quartiary Master"	;;
			h) disk="Quartiary Slave"	;;
		esac
		case $(cat /proc/ide/hd$i/media) in
			disk)
				MULTIPLE_IO=`$HDPARM -i /dev/hd$i | grep "MaxMultSect=" | cut -d, -f3 | cut -d= -f2`
				[ -n "$MULTIPLE_IO" ] && [ "$MULTIPLE_IO"	!= "0" ] 2>/dev/null && HDFLAGS="-q -m$MULTIPLE_IO"
				dev="hard drive"
			;;
			cdrom)
				[ -n "$SPEED"		] && [ "$SPEED"			!= "0" ] 2>/dev/null && HDFLAGS="-q -E$SPEED"
				dev="CD-ROM"
			;;
		esac
		[ -n "$LOOKAHEAD"	 ] && [ "$LOOKAHEAD"	!= "0" ] 2>/dev/null && HDFLAGS="$HDFLAGS -q -A$LOOKAHEAD"
		[ -n "$USE_DMA"		 ] && [ "$USE_DMA"		!= "0" ] 2>/dev/null && HDFLAGS="$HDFLAGS -q -d$USE_DMA"
		[ -n "$EIDE_32BIT"	 ] && [ "$EIDE_32BIT"	!= "0" ] 2>/dev/null && HDFLAGS="$HDFLAGS -q -c$EIDE_32BIT"
		[ -n "$UNMASKIRQ"	 ] && [ "$UNMASKIRQ"	!= "0" ] 2>/dev/null && HDFLAGS="$HDFLAGS -q -u$UNMASKIRQ"
		[ -n "$EXTRA_PARAMS" ]											 && HDFLAGS="$HDFLAGS $EXTRA_PARAMS"
		[ -n "$HDFLAGS" ] && action "Setting $dev parameters for $disk:" "$HDPARM" $HDFLAGS /dev/hd$i
	fi
done
